﻿// -----------------------------------------------------------------------
// <copyright file="EmbeddedInteger64.cs" company="">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace Dhgms.TplHelper.Controller.Task.Sql
{
    using System.Data.Common;
    using System.Data.SqlClient;
    using System.Diagnostics.CodeAnalysis;
    using System.Reflection;

    using Dhgms.DataManager.Model.Helper.Database;
    using Dhgms.TplHelper.Model.Info.TaskResult;
    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    public abstract class EmbeddedInteger64<TDatabaseHelperClass, TParameterClass> :
        Embedded<SingleResultInteger64, TDatabaseHelperClass, TParameterClass>
        where TDatabaseHelperClass : Base<TParameterClass>, new() where TParameterClass : DbParameter
    {
        #region Constructors and Destructors

        /// <summary>
        /// Initializes a new instance of the <see cref="EmbeddedInteger32{TDatabaseHelperClass,TParameterClass}"/> class. 
        /// </summary>
        /// <param name="taskName">
        /// </param>
        /// <param name="connectionString">
        /// </param>
        /// <param name="assembly">
        /// </param>
        /// <param name="resourceNamespace">
        /// </param>
        /// <param name="resourceFileName">
        /// </param>
        /// <param name="assumeSqlSafe">
        /// Whether to skip the SQL injection safety check.  Use only if you know the code you are passing in is safe and contains a quoted string that is preventing it passing the saftey check
        /// </param>
        protected EmbeddedInteger64(
            string taskName, 
            string connectionString, 
            Assembly assembly, 
            string resourceNamespace, 
            string resourceFileName, 
            bool assumeSqlSafe)
            : base(taskName, connectionString, assembly, resourceNamespace, resourceFileName, assumeSqlSafe)
        {
        }

        #endregion

        #region Methods

        /// <summary>
        /// The OnProcess event for doing the donkey work
        /// </summary>
        /// <param name="result">
        /// The result.
        /// </param>
        protected override void OnProcess(SingleResultInteger64 result)
        {
            result.Result = this.DbHelper.GetInteger64(
                this.ConnectionString, this.GetSql(), this.GetParameters(), this.AssumeSqlSafe);
        }

        #endregion
    }
}
