﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright company="DHGMS Solutions" file="NoDataReaderException.cs">
//   2004-2012 DHGMS Solutions. Some Rights Reserved. Licensed under GNU General Public License version 2 (GPLv2)
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace Dhgms.TplHelper.Model.Exception
{
    using System;
    using System.Runtime.Serialization;

    /// <summary>
    /// We failed to get the resource stream. Used when loading a resource file.
    /// </summary>
    [Serializable]
    public class NoDataReaderException : Exception
    {
        #region Constructors and Destructors

        /// <summary>
        /// Initializes a new instance of the <see cref="NoDataReaderException"/> class. 
        /// </summary>
        public NoDataReaderException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NoDataReaderException"/> class. 
        /// </summary>
        /// <param name="message">
        /// Exception Message
        /// </param>
        public NoDataReaderException(string message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NoDataReaderException"/> class. 
        /// </summary>
        /// <param name="message">
        /// Exception Message
        /// </param>
        /// <param name="innerException">
        /// Inner Exception
        /// </param>
        public NoDataReaderException(string message, Exception innerException)
            : base(message, innerException)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NoDataReaderException"/> class. 
        /// </summary>
        /// <param name="info">
        /// Serialization Info
        /// </param>
        /// <param name="context">
        /// Context
        /// </param>
        protected NoDataReaderException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        #endregion
    }
}