﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright company="DHGMS Solutions" file="DestinationTableDeleteAction.cs">
//   2004-2012 DHGMS Solutions. Some Rights Reserved. Licensed under GNU General Public License version 2 (GPLv2)
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace Dhgms.TplHelper.Model.Info
{
    /// <summary>
    /// Defines the actions that can be taken on a destination table for a bulk copy
    /// </summary>
    public enum DestinationTableDeleteAction
    {
        /// <summary>
        /// No action of the table
        /// </summary>
        None, 

        /// <summary>
        /// Truncates the table
        /// </summary>
        Truncate, 

        /// <summary>
        /// Deletes the contents of a table and uses the reseed index command
        /// Used when a target table has foreign keys
        /// </summary>
        WipeAndReseed
    }
}