﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright company="DHGMS Solutions" file="Base.cs">
//   2004-2012 DHGMS Solutions. Some Rights Reserved. Licensed under GNU General Public License version 2 (GPLv2)
// </copyright>
// --------------------------------------------------------------------------------------------------------------------

namespace Dhgms.TplHelper.Model.Info.JobResult
{
    using System.Net.Mail;

    /// <summary>
    /// Base class for a job result
    /// </summary>
    public class Base
    {
        #region Constructors and Destructors

        /// <summary>
        /// Initializes a new instance of the <see cref="Base"/> class. 
        /// </summary>
        public Base()
        {
            this.EmailRecipients = new MailAddressCollection();
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Base"/> class. 
        /// </summary>
        /// <param name="emailRecipients">
        /// The email Recipients.
        /// </param>
        public Base(MailAddressCollection emailRecipients)
        {
            this.EmailRecipients = emailRecipients;
        }

        #endregion

        #region Public Properties

        /// <summary>
        /// Collection of Email Recipients
        /// </summary>
        public MailAddressCollection EmailRecipients { get; set; }

        #endregion
    }
}