﻿//////////////////////////////////////////////////////////////////////////
// Licensed under GNU General Public License version 2 (GPLv2)
//
// TPL Helper Library by DHGMS Solutions
// http://tplhelper.codeplex.com
//////////////////////////////////////////////////////////////////////////

namespace Dhgms.TplHelper.Model.Info.TaskResult
{
        using System;
        using System.ComponentModel.DataAnnotations;
        using System.Data.Entity;
        using System.Diagnostics;
        using System.Diagnostics.CodeAnalysis;
        using System.Runtime.Serialization;
        using System.Xml;
        using System.Xml.Linq;

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Represents the base task result
        /// </summary>
        [DataContract]
        public class Base
// ReSharper disable RedundantNameQualifier
            : Dhgms.DataManager.Model.Info.Base<Base>
// ReSharper restore RedundantNameQualifier
        {
        #region fields
            /// <summary>
            /// Name of the task
            /// </summary>
            [SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1121:UseBuiltInTypeAlias", Justification = "Reviewed. Suppression is OK here.")]
            private string name;

        #endregion

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="Base"/> class.
        /// </summary>
        public Base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Base"/> class.
        /// </summary>
        /// <param name="other">
        /// Object to copy
        /// </param>
        public Base(Base other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }

            this.Name = other.Name;
            this.Started = other.Started;
            this.Finished = other.Finished;
        }

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="Base"/> class.
        /// </summary>
        /// <param name="name">Name of the task</param>
        /// <param name="started">Timestamp of when the task started</param>
        /// <param name="finished">Timestamp of when the task finished</param>
        public Base(
            string name,
            DateTime started,
            DateTime finished)
            {
            this.Name = name;
            this.Started = started;
            this.Finished = finished;
        }

            /// <summary>
            /// The on disposing event
            /// </summary>
            protected override void OnDisposing()
            {
            }
        #region properties
        /// <summary>
        /// Gets or sets Name of the task
        /// </summary>
        [SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1121:UseBuiltInTypeAlias", Justification = "Reviewed. Suppression is OK here.")]
        [DataMember(IsRequired = true,Order = 1)]
        [Required]
//[MinLength(0, ErrorMessage="Must be at least 0 characters in length")]
        public string Name
        {
            get
            {
                return this.name;
            }

            set
        {
            if(value  != null && value.Length < 0)
            {
                // ReSharper disable RedundantNameQualifier
                throw new Dhgms.DataManager.Model.Exception.StringTooShortException(0, value.Length);
                // ReSharper restore RedundantNameQualifier
            }
            this.name = value;
        }
        }

        /// <summary>
        /// Gets or sets Timestamp of when the task started
        /// </summary>
        [SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1121:UseBuiltInTypeAlias", Justification = "Reviewed. Suppression is OK here.")]
        [DataMember(IsRequired = true,Order = 2)]
        [Required]
[Range(typeof(System.DateTime), "", "")]
        public DateTime Started
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets Timestamp of when the task finished
        /// </summary>
        [SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1121:UseBuiltInTypeAlias", Justification = "Reviewed. Suppression is OK here.")]
        [DataMember(IsRequired = true,Order = 3)]
        [Required]
[Range(typeof(System.DateTime), "", "")]
        public DateTime Finished
        {
            get;
            set;
        }

            /// <summary>
            /// Gets a header record for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the header record</returns>
            public override System.Collections.Generic.IList<string> HeaderRecord
            {
                get
                {
                    var result = new System.Collections.Generic.List<string>
                    {
                        "Name",
                        "Started",
                        "Finished"
                    };

                    return result;
                }
            }

        #endregion

        #region IComparable methods

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Compares the current instance with another object of the same type.
        /// </summary>
        /// <param name="other">
        /// The instance to compare to
        /// </param>
        /// <returns>
        /// 0 if equal, otherwise non zero
        /// </returns>
        public override int CompareTo(Base other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }

            // Name
            var checkResult = string.CompareOrdinal(this.Name, other.Name);

            if (checkResult != 0)
            {
                return (checkResult > 0) ? 1 : -1;
            }

            // Started
            checkResult = this.Started.CompareTo(other.Started);

            if (checkResult != 0)
            {
                return (checkResult > 0) ? 2 : -2;
            }

            // Finished
            checkResult = this.Finished.CompareTo(other.Finished);

            if (checkResult != 0)
            {
                return (checkResult > 0) ? 3 : -3;
            }

            return 0;
        }

        #endregion
#region IEquatable methods
            /// <summary>
            /// Checks if the current instance matches another of the same type
            /// </summary>
            /// <param name="other">object to compare</param>
            /// <returns>true if equal, otherwise false</returns>
            public override bool Equals(Base other)
            {
                return this.CompareTo(other) == 0;
            }

#endregion

    #region our methods

        /// <summary>
        /// Gets the hash code for the object
        /// </summary>
        /// <returns>hash code</returns>
        public override int GetHashCode()
        {
            return
                (this.Name != null ? this.Name.GetHashCode() : 0)
                ^ this.Started.GetHashCode()
                ^ this.Finished.GetHashCode();
        }

        /// <summary>
        /// Checks a table to ensure it meets the required schema
        /// </summary>
        public override void DoTableValidation()
        {
        }

            /// <summary>
            /// Gets a collection of string data for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the data record</returns>
            public override System.Collections.Generic.IList<string> ToStringArray()
            {
                var result = new System.Collections.Generic.List<string>
                {
                    this.Name,
                    this.Started.ToString("yyyy-MM-dd HH:mm:ss"),
                    this.Finished.ToString("yyyy-MM-dd HH:mm:ss")
                };

                return result;
            }

            /// <summary>
            /// Adds an XML Element to an XML Writer
            /// </summary>
            /// <param name="writer">
            /// The XML writer to add the element to.
            /// </param>
            /// <param name="parentElementName">
            /// The name for the parenet element being produced.
            /// </param>
            public override void DoXmlElement(
                    System.Xml.XmlWriter writer,
                    string parentElementName)
            {
            if (writer == null)
            {
                throw new ArgumentNullException("writer");
            }

            if (string.IsNullOrEmpty(parentElementName) || parentElementName.Trim().Length == 0)
            {
            throw new ArgumentNullException("parentElementName");
            }

                writer.WriteStartElement(parentElementName);

                // Name
                this.DoChildXmlCDataElement(writer, "Name", this.Name);

                // Started
                this.DoChildXmlCDataElement(writer, "Started", this.Started.ToString("yyyy-MM-dd HH:mm:ss"));

                // Finished
                this.DoChildXmlCDataElement(writer, "Finished", this.Finished.ToString("yyyy-MM-dd HH:mm:ss"));

                writer.WriteEndElement();
            }

        /// <summary>
        /// Checks this instance against another to see where there are differences
        /// </summary>
        /// <param name="other">other instance to compare</param>
        /// <returns>summary of where there are differences</returns>
// ReSharper disable RedundantNameQualifier
        public Dhgms.TplHelper.Model.Difference.TaskResult.BaseDifference GetDifferences(Base other)
// ReSharper restore RedundantNameQualifier
        {
            if (other == null)
            {
                throw new System.ArgumentNullException("other");
            }

            // Name
            var checkResult = string.CompareOrdinal(this.Name, other.Name);

            var name = checkResult != 0;

            // Started
            checkResult = this.Started.CompareTo(other.Started);

            var started = checkResult != 0;

            // Finished
            checkResult = this.Finished.CompareTo(other.Finished);

            var finished = checkResult != 0;

// ReSharper disable RedundantNameQualifier
            return new Dhgms.TplHelper.Model.Difference.TaskResult.BaseDifference(
// ReSharper restore RedundantNameQualifier
                name
                ,started
                ,finished
                );
        }

        /// <summary>
        /// Gets the CDSL that defines the OData Vocabularies for this class
        /// </summary>
        public static XmlReader GetOdataVocabularies()
        {
            // Name

            // Started

            // Finished

        var schema = new XElement(
            "Schema",
            new XAttribute("Namespace", "Dhgms.TplHelper.TaskResult"),
            new XAttribute("xmlns", "http://schemas.microsoft.com/ado/2009/11/edm"),
            // using directive
            new XElement(
                "Using",
                new XAttribute("Namespace", "Org.OData.Validation.V1"),
                new XAttribute("Alias", "Validation"),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.Base/Name")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.Base/Started")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.Base/Finished"))));

        Debug.Assert(schema.Document != null, "schema.Document != null");
        return schema.Document.CreateReader();
        }
        #endregion
    }
}

namespace Dhgms.TplHelper.Model.Difference.TaskResult
{
        using System;
        using System.ComponentModel.DataAnnotations;
        using System.Data.Entity;
        using System.Diagnostics;
        using System.Diagnostics.CodeAnalysis;
        using System.Runtime.Serialization;
        using System.Xml;
        using System.Xml.Linq;

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Represents the base task result
        /// </summary>
        [DataContract]
        public class BaseDifference
// ReSharper disable RedundantNameQualifier
            : Dhgms.DataManager.Model.Info.Difference<BaseDifference>
// ReSharper restore RedundantNameQualifier
        {
        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="BaseDifference"/> class.
        /// </summary>
        public BaseDifference()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BaseDifference"/> class.
        /// </summary>
        /// <param name="other">
        /// Object to copy
        /// </param>
        public BaseDifference(BaseDifference other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }

            this.Name = other.Name;
            this.Started = other.Started;
            this.Finished = other.Finished;
        }

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="BaseDifference"/> class.
        /// </summary>
        /// <param name="name">Name of the task</param>
        /// <param name="started">Timestamp of when the task started</param>
        /// <param name="finished">Timestamp of when the task finished</param>
        public BaseDifference(
            bool name,
            bool started,
            bool finished)
            {
            this.Name = name;
            this.Started = started;
            this.Finished = finished;
        }

            /// <summary>
            /// The on disposing event
            /// </summary>
            protected override void OnDisposing()
            {
            }
        #region properties
        /// <summary>
        /// Name of the task
        /// </summary>
        public bool Name
        {
            get;
            set;
        }

        /// <summary>
        /// Timestamp of when the task started
        /// </summary>
        public bool Started
        {
            get;
            set;
        }

        /// <summary>
        /// Timestamp of when the task finished
        /// </summary>
        public bool Finished
        {
            get;
            set;
        }

            /// <summary>
            /// Gets a header record for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the header record</returns>
            public override System.Collections.Generic.IList<string> HeaderRecord
            {
                get
                {
                    var result = new System.Collections.Generic.List<string>
                    {
                        "Name",
                        "Started",
                        "Finished"
                    };

                    return result;
                }
            }

            /// <summary>
            /// Gets the number of properties that are different
            /// </summary>
            /// <return>
            /// the number of properties that are different
            /// </return>
            public override int Count
            {
                get
                {
                    return
                    ((Name) ? 1 : 0)
                    + ((Started) ? 1 : 0)
                    + ((Finished) ? 1 : 0)
                    ;
                }
            }

        #endregion

        #region IComparable methods

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Compares the current instance with another object of the same type.
        /// </summary>
        /// <param name="other">
        /// The instance to compare to
        /// </param>
        /// <returns>
        /// 0 if equal, otherwise non zero
        /// </returns>
        public override int CompareTo(BaseDifference other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }

            int             checkResult = Name.CompareTo(other.Name);
            if(checkResult != 0)
            {
                return (checkResult > 0) ? 1 : -1;
            }

                        checkResult = Started.CompareTo(other.Started);
            if(checkResult != 0)
            {
                return (checkResult > 0) ? 2 : -2;
            }

                        checkResult = Finished.CompareTo(other.Finished);
            if(checkResult != 0)
            {
                return (checkResult > 0) ? 3 : -3;
            }

            return 0;
        }

        #endregion
#region IEquatable methods
            /// <summary>
            /// Checks if the current instance matches another of the same type
            /// </summary>
            /// <param name="other">object to compare</param>
            /// <returns>true if equal, otherwise false</returns>
            public override bool Equals(BaseDifference other)
            {
                return this.CompareTo(other) == 0;
            }

#endregion

    #region our methods

        /// <summary>
        /// Gets the hash code for the object
        /// </summary>
        /// <returns>hash code</returns>
        public override int GetHashCode()
        {
            return
                this.Name.GetHashCode()
                ^ this.Started.GetHashCode()
                ^ this.Finished.GetHashCode();
        }

        /// <summary>
        /// Checks a table to ensure it meets the required schema
        /// </summary>
        public override void DoTableValidation()
        {
        }

            /// <summary>
            /// Gets a collection of string data for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the data record</returns>
            public override System.Collections.Generic.IList<string> ToStringArray()
            {
                var result = new System.Collections.Generic.List<string>
                {
                    this.Name ? "1" : "0",
                    this.Started ? "1" : "0",
                    this.Finished ? "1" : "0"
                };

                return result;
            }

            /// <summary>
            /// Adds an XML Element to an XML Writer
            /// </summary>
            /// <param name="writer">
            /// The XML writer to add the element to.
            /// </param>
            /// <param name="parentElementName">
            /// The name for the parenet element being produced.
            /// </param>
            public override void DoXmlElement(
                    System.Xml.XmlWriter writer,
                    string parentElementName)
            {
            if (writer == null)
            {
                throw new ArgumentNullException("writer");
            }

            if (string.IsNullOrEmpty(parentElementName) || parentElementName.Trim().Length == 0)
            {
            throw new ArgumentNullException("parentElementName");
            }

                writer.WriteStartElement(parentElementName);

                // Name
                this.DoChildXmlCDataElement(writer, "Name", this.Name ? "1" : "0");

                // Started
                this.DoChildXmlCDataElement(writer, "Started", this.Started ? "1" : "0");

                // Finished
                this.DoChildXmlCDataElement(writer, "Finished", this.Finished ? "1" : "0");

                writer.WriteEndElement();
            }


        /// <summary>
        /// Gets the names of the columns that are different
        /// </summary>
        /// <returns>
        /// list of names of the columns that are different
        /// </returns>
        public override System.Collections.Generic.IList<string> GetColumnNames()
        {
            var columns = new System.Collections.Generic.List<string>();
            if (this.Name)
            {
                columns.Add("Name");
            }

            if (this.Started)
            {
                columns.Add("Started");
            }

            if (this.Finished)
            {
                columns.Add("Finished");
            }

            return columns;
        }

        /// <summary>
        /// Gets the CDSL that defines the OData Vocabularies for this class
        /// </summary>
        public static XmlReader GetOdataVocabularies()
        {
            // Name

            // Started

            // Finished

        var schema = new XElement(
            "Schema",
            new XAttribute("Namespace", "Dhgms.TplHelper.TaskResult"),
            new XAttribute("xmlns", "http://schemas.microsoft.com/ado/2009/11/edm"),
            // using directive
            new XElement(
                "Using",
                new XAttribute("Namespace", "Org.OData.Validation.V1"),
                new XAttribute("Alias", "Validation"),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.Base/Name")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.Base/Started")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.Base/Finished"))));

        Debug.Assert(schema.Document != null, "schema.Document != null");
        return schema.Document.CreateReader();
        }
        #endregion
    }
}

