﻿//////////////////////////////////////////////////////////////////////////
// Licensed under GNU General Public License version 2 (GPLv2)
//
// TPL Helper Library by DHGMS Solutions
// http://tplhelper.codeplex.com
//////////////////////////////////////////////////////////////////////////

namespace Dhgms.TplHelper.Model.Info.TaskResult
{
        using System;
        using System.ComponentModel.DataAnnotations;
        using System.Data.Entity;
        using System.Diagnostics;
        using System.Diagnostics.CodeAnalysis;
        using System.Runtime.Serialization;
        using System.Xml;
        using System.Xml.Linq;

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Represents the result of a task the processes a batch of records
        /// </summary>
        [DataContract]
        public class RecordProcessor
// ReSharper disable RedundantNameQualifier
            : Base
// ReSharper restore RedundantNameQualifier
        {
        #region fields
            /// <summary>
            /// Number of records processed
            /// </summary>
            [SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1121:UseBuiltInTypeAlias", Justification = "Reviewed. Suppression is OK here.")]
            private int recordsProcessed;

        #endregion

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="RecordProcessor"/> class.
        /// </summary>
        public RecordProcessor()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RecordProcessor"/> class.
        /// </summary>
        /// <param name="other">
        /// Object to copy
        /// </param>
        public RecordProcessor(RecordProcessor other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }

            this.RecordsProcessed = other.RecordsProcessed;
        }

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="RecordProcessor"/> class.
        /// </summary>
        /// <param name="name">Name of the task</param>
        /// <param name="started">Timestamp of when the task started</param>
        /// <param name="finished">Timestamp of when the task finished</param>
        /// <param name="recordsProcessed">Number of records processed</param>
        public RecordProcessor(
            string name,            DateTime started,            DateTime finished,            int recordsProcessed)
            : base(
                name,
                started,
                finished)
            {
            this.RecordsProcessed = recordsProcessed;
        }

            /// <summary>
            /// The on disposing event
            /// </summary>
            protected override void OnDisposing()
            {
                base.OnDisposing();
            }
        #region properties
        /// <summary>
        /// Gets or sets Number of records processed
        /// </summary>
        [SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1121:UseBuiltInTypeAlias", Justification = "Reviewed. Suppression is OK here.")]
        [DataMember(IsRequired = true,Order = 1)]
        [Required]
[Range(typeof(int), "0", "")]
        public int RecordsProcessed
        {
            get
            {
                return this.recordsProcessed;
            }

            set
        {
            if(value < 0)
            {
                // ReSharper disable RedundantNameQualifier
                throw new Dhgms.DataManager.Model.Exception.NumberTooLowInteger32Exception("RecordsProcessed",0, value);
                // ReSharper restore RedundantNameQualifier
            }
            this.recordsProcessed = value;
        }
        }

            /// <summary>
            /// Gets a header record for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the header record</returns>
            public override System.Collections.Generic.IList<string> HeaderRecord
            {
                get
                {
                    var result = new System.Collections.Generic.List<string>(base.HeaderRecord)
                    {
                        "RecordsProcessed"
                    };

                    return result;
                }
            }

        #endregion

        #region IComparable methods

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Compares the current instance with another object of the same type.
        /// </summary>
        /// <param name="other">
        /// The instance to compare to
        /// </param>
        /// <returns>
        /// 0 if equal, otherwise non zero
        /// </returns>
        public int CompareTo(RecordProcessor other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }


        var checkResult = base.CompareTo(other);
        if (checkResult != 0)
        {
            return checkResult;
        }

            // RecordsProcessed
            checkResult = this.RecordsProcessed.CompareTo(other.RecordsProcessed);

            if (checkResult != 0)
            {
                return (checkResult > 0) ? 4 : -4;
            }

            return 0;
        }

        #endregion
#region IEquatable methods
            /// <summary>
            /// Checks if the current instance matches another of the same type
            /// </summary>
            /// <param name="other">object to compare</param>
            /// <returns>true if equal, otherwise false</returns>
            public bool Equals(RecordProcessor other)
            {
                return this.CompareTo(other) == 0;
            }

#endregion

    #region our methods

        /// <summary>
        /// Gets the hash code for the object
        /// </summary>
        /// <returns>hash code</returns>
        public override int GetHashCode()
        {
            return
                base.GetHashCode() ^
                this.RecordsProcessed.GetHashCode()
                ^ this.RecordsProcessed.GetHashCode();
        }

        /// <summary>
        /// Checks a table to ensure it meets the required schema
        /// </summary>
        public override void DoTableValidation()
        {
        }

            /// <summary>
            /// Gets a collection of string data for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the data record</returns>
            public override System.Collections.Generic.IList<string> ToStringArray()
            {
                var result = new System.Collections.Generic.List<string>(base.ToStringArray())

                {
                    this.RecordsProcessed.ToString(System.Globalization.CultureInfo.InvariantCulture)
                };

                return result;
            }

            /// <summary>
            /// Adds an XML Element to an XML Writer
            /// </summary>
            /// <param name="writer">
            /// The XML writer to add the element to.
            /// </param>
            /// <param name="parentElementName">
            /// The name for the parenet element being produced.
            /// </param>
            public override void DoXmlElement(
                    System.Xml.XmlWriter writer,
                    string parentElementName)
            {
            if (writer == null)
            {
                throw new ArgumentNullException("writer");
            }

            if (string.IsNullOrEmpty(parentElementName) || parentElementName.Trim().Length == 0)
            {
            throw new ArgumentNullException("parentElementName");
            }

                writer.WriteStartElement(parentElementName);

                // Name
                this.DoChildXmlCDataElement(writer, "Name", this.Name);

                // Started
                this.DoChildXmlCDataElement(writer, "Started", this.Started.ToString("yyyy-MM-dd HH:mm:ss"));

                // Finished
                this.DoChildXmlCDataElement(writer, "Finished", this.Finished.ToString("yyyy-MM-dd HH:mm:ss"));

                // RecordsProcessed
                this.DoChildXmlCDataElement(writer, "RecordsProcessed", this.RecordsProcessed.ToString(System.Globalization.CultureInfo.InvariantCulture));

                writer.WriteEndElement();
            }

        /// <summary>
        /// Checks this instance against another to see where there are differences
        /// </summary>
        /// <param name="other">other instance to compare</param>
        /// <returns>summary of where there are differences</returns>
// ReSharper disable RedundantNameQualifier
        public Dhgms.TplHelper.Model.Difference.TaskResult.RecordProcessorDifference GetDifferences(RecordProcessor other)
// ReSharper restore RedundantNameQualifier
        {
            if (other == null)
            {
                throw new System.ArgumentNullException("other");
            }

            // Name
            var checkResult = string.CompareOrdinal(this.Name, other.Name);

            var name = checkResult != 0;

            // Started
            checkResult = this.Started.CompareTo(other.Started);

            var started = checkResult != 0;

            // Finished
            checkResult = this.Finished.CompareTo(other.Finished);

            var finished = checkResult != 0;

            // RecordsProcessed
            checkResult = this.RecordsProcessed.CompareTo(other.RecordsProcessed);

            var recordsProcessed = checkResult != 0;

// ReSharper disable RedundantNameQualifier
            return new Dhgms.TplHelper.Model.Difference.TaskResult.RecordProcessorDifference(
// ReSharper restore RedundantNameQualifier
                name
                ,started
                ,finished
                ,recordsProcessed
                );
        }

        /// <summary>
        /// Gets the CDSL that defines the OData Vocabularies for this class
        /// </summary>
        public static new XmlReader GetOdataVocabularies()
        {
            // RecordsProcessed

        var schema = new XElement(
            "Schema",
            new XAttribute("Namespace", "Dhgms.TplHelper.TaskResult"),
            new XAttribute("xmlns", "http://schemas.microsoft.com/ado/2009/11/edm"),
            // using directive
            new XElement(
                "Using",
                new XAttribute("Namespace", "Org.OData.Validation.V1"),
                new XAttribute("Alias", "Validation"),
                new XElement("Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/Name")),
                new XElement("Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/Started")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/Finished")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/RecordsProcessed"))));

        Debug.Assert(schema.Document != null, "schema.Document != null");
        return schema.Document.CreateReader();
        }
        #endregion
    }
}

namespace Dhgms.TplHelper.Model.Difference.TaskResult
{
        using System;
        using System.ComponentModel.DataAnnotations;
        using System.Data.Entity;
        using System.Diagnostics;
        using System.Diagnostics.CodeAnalysis;
        using System.Runtime.Serialization;
        using System.Xml;
        using System.Xml.Linq;

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Represents the result of a task the processes a batch of records
        /// </summary>
        [DataContract]
        public class RecordProcessorDifference
// ReSharper disable RedundantNameQualifier
            : BaseDifference
// ReSharper restore RedundantNameQualifier
        {
        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="RecordProcessorDifference"/> class.
        /// </summary>
        public RecordProcessorDifference()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="RecordProcessorDifference"/> class.
        /// </summary>
        /// <param name="other">
        /// Object to copy
        /// </param>
        public RecordProcessorDifference(RecordProcessorDifference other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }

            this.RecordsProcessed = other.RecordsProcessed;
        }

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Initializes a new instance of the <see cref="RecordProcessorDifference"/> class.
        /// </summary>
        /// <param name="name">Name of the task</param>
        /// <param name="started">Timestamp of when the task started</param>
        /// <param name="finished">Timestamp of when the task finished</param>
        /// <param name="recordsProcessed">Number of records processed</param>
        public RecordProcessorDifference(
            bool name,            bool started,            bool finished,            bool recordsProcessed)
            : base(
                name,
                started,
                finished)
            {
            this.RecordsProcessed = recordsProcessed;
        }

            /// <summary>
            /// The on disposing event
            /// </summary>
            protected override void OnDisposing()
            {
            }
        #region properties
        /// <summary>
        /// Number of records processed
        /// </summary>
        public bool RecordsProcessed
        {
            get;
            set;
        }

            /// <summary>
            /// Gets a header record for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the header record</returns>
            public override System.Collections.Generic.IList<string> HeaderRecord
            {
                get
                {
                    var result = new System.Collections.Generic.List<string>(base.HeaderRecord)
                    {
                        "RecordsProcessed"
                    };

                    return result;
                }
            }

            /// <summary>
            /// Gets the number of properties that are different
            /// </summary>
            /// <return>
            /// the number of properties that are different
            /// </return>
            public override int Count
            {
                get
                {
                    return
                    ((RecordsProcessed) ? 1 : 0)
                    ;
                }
            }

        #endregion

        #region IComparable methods

        // ********** WARNING **********
        // This code is automatically generated! Any Changes you make to this file will be lost!
        // To make changes edit the corresponding .tt file!

        /// <summary>
        /// Compares the current instance with another object of the same type.
        /// </summary>
        /// <param name="other">
        /// The instance to compare to
        /// </param>
        /// <returns>
        /// 0 if equal, otherwise non zero
        /// </returns>
        public int CompareTo(RecordProcessorDifference other)
        {
            if (other == null)
            {
                throw new ArgumentNullException("other");
            }


        var checkResult = base.CompareTo(other);
        if (checkResult != 0)
        {
            return checkResult;
        }

                        checkResult = RecordsProcessed.CompareTo(other.RecordsProcessed);
            if(checkResult != 0)
            {
                return (checkResult > 0) ? 4 : -4;
            }

            return 0;
        }

        #endregion
#region IEquatable methods
            /// <summary>
            /// Checks if the current instance matches another of the same type
            /// </summary>
            /// <param name="other">object to compare</param>
            /// <returns>true if equal, otherwise false</returns>
            public bool Equals(RecordProcessorDifference other)
            {
                return this.CompareTo(other) == 0;
            }

#endregion

    #region our methods

        /// <summary>
        /// Gets the hash code for the object
        /// </summary>
        /// <returns>hash code</returns>
        public override int GetHashCode()
        {
            return
                base.GetHashCode() ^
                this.RecordsProcessed.GetHashCode()
                ^ this.RecordsProcessed.GetHashCode();
        }

        /// <summary>
        /// Checks a table to ensure it meets the required schema
        /// </summary>
        public override void DoTableValidation()
        {
        }

            /// <summary>
            /// Gets a collection of string data for use for something like a CSV file
            /// </summary>
            /// <returns>a collection of strings representing the data record</returns>
            public override System.Collections.Generic.IList<string> ToStringArray()
            {
                var result = new System.Collections.Generic.List<string>(base.ToStringArray())

                {
                    this.RecordsProcessed ? "1" : "0"
                };

                return result;
            }

            /// <summary>
            /// Adds an XML Element to an XML Writer
            /// </summary>
            /// <param name="writer">
            /// The XML writer to add the element to.
            /// </param>
            /// <param name="parentElementName">
            /// The name for the parenet element being produced.
            /// </param>
            public override void DoXmlElement(
                    System.Xml.XmlWriter writer,
                    string parentElementName)
            {
            if (writer == null)
            {
                throw new ArgumentNullException("writer");
            }

            if (string.IsNullOrEmpty(parentElementName) || parentElementName.Trim().Length == 0)
            {
            throw new ArgumentNullException("parentElementName");
            }

                writer.WriteStartElement(parentElementName);

                // Name
                this.DoChildXmlCDataElement(writer, "Name", this.Name ? "1" : "0");

                // Started
                this.DoChildXmlCDataElement(writer, "Started", this.Started ? "1" : "0");

                // Finished
                this.DoChildXmlCDataElement(writer, "Finished", this.Finished ? "1" : "0");

                // RecordsProcessed
                this.DoChildXmlCDataElement(writer, "RecordsProcessed", this.RecordsProcessed ? "1" : "0");

                writer.WriteEndElement();
            }


        /// <summary>
        /// Gets the names of the columns that are different
        /// </summary>
        /// <returns>
        /// list of names of the columns that are different
        /// </returns>
        public override System.Collections.Generic.IList<string> GetColumnNames()
        {
            var columns = new System.Collections.Generic.List<string>();
            columns.AddRange(base.GetColumnNames());
            if (this.RecordsProcessed)
            {
                columns.Add("RecordsProcessed");
            }

            return columns;
        }

        /// <summary>
        /// Gets the CDSL that defines the OData Vocabularies for this class
        /// </summary>
        public static new XmlReader GetOdataVocabularies()
        {
            // RecordsProcessed

        var schema = new XElement(
            "Schema",
            new XAttribute("Namespace", "Dhgms.TplHelper.TaskResult"),
            new XAttribute("xmlns", "http://schemas.microsoft.com/ado/2009/11/edm"),
            // using directive
            new XElement(
                "Using",
                new XAttribute("Namespace", "Org.OData.Validation.V1"),
                new XAttribute("Alias", "Validation"),
                new XElement("Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/Name")),
                new XElement("Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/Started")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/Finished")),
                new XElement(
                    "Annotations",
                    new XAttribute("Target", "Dhgms.TplHelper.TaskResult.RecordProcessor/RecordsProcessed"))));

        Debug.Assert(schema.Document != null, "schema.Document != null");
        return schema.Document.CreateReader();
        }
        #endregion
    }
}

